'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var hljs = _interopDefault(require('highlight.js'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var Highlight = /** @class */ (function (_super) {
    __extends(Highlight, _super);
    function Highlight() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { codeStr: '' };
        return _this;
    }
    Highlight.prototype.componentDidUpdate = function (prev) {
        if (prev.children !== this.props.children) {
            this.setState({ codeStr: '' });
            return;
        }
        if (this.state.codeStr && this.state.codeStr.length > 0) {
            return;
        }
        this.highlightCode();
    };
    Highlight.prototype.componentDidMount = function () {
        this.highlightCode();
    };
    Highlight.prototype.highlightCode = function () {
        var _a = this.props, children = _a.children, languages = _a.languages;
        if (languages && languages.length === 1) {
            var ans = hljs.highlight(languages[0], children);
            this.setState({ codeStr: ans.value });
        }
        else {
            var ans = hljs.highlightAuto(children, languages);
            this.setState({ codeStr: ans.value });
        }
    };
    Highlight.prototype.render = function () {
        var languages = this.props.languages;
        var cls = [languages ? languages[0] : '', 'hljs'].join(' ');
        return (React.createElement("pre", null,
            React.createElement("code", { className: cls, dangerouslySetInnerHTML: { __html: this.state.codeStr } })));
    };
    Highlight.defaultProps = {
        children: '',
        languages: []
    };
    return Highlight;
}(React.PureComponent));

var CodeCard = function (props) {
    var className = props.className, children = props.children, rest = __rest(props, ["className", "children"]);
    var cls = ['codecard hljs', className ? className : ''].join(' ');
    return (React.createElement("div", { className: cls, style: {
            padding: '14px',
            position: 'relative',
            overflow: 'auto',
            borderRadius: '8px',
            boxShadow: 'rgba(0, 0, 0, 0.55) 0 8px 16px',
            margin: '1.5rem 0'
        } },
        React.createElement("div", { className: 'codecard-head', style: {
                display: 'flex',
                justifyContent: 'flex-start',
                alignItems: 'center'
            } },
            React.createElement("div", { className: 'circle red', style: {
                    width: '12px',
                    height: '12px',
                    borderRadius: '50%',
                    margin: '0 6px 0 0',
                    background: '#ff5f56',
                    border: '0.5px solid #e0443e'
                } }),
            React.createElement("div", { className: 'circle yellow', style: {
                    width: '12px',
                    height: '12px',
                    borderRadius: '50%',
                    margin: '0 6px 0 0',
                    background: '#ffbd2e',
                    border: '0.5px solid #dea123'
                } }),
            React.createElement("div", { className: 'circle green', style: {
                    width: '12px',
                    height: '12px',
                    borderRadius: '50%',
                    margin: '0 6px 0 0',
                    background: '#27c93f',
                    border: '0.5px solid #1aab29'
                } })),
        React.createElement(Highlight, __assign({}, rest), children)));
};
CodeCard.defaultProps = {
    className: '',
    languages: []
};

exports.CodeCard = CodeCard;
